#!/usr/bin/env python

# parse_ping1.py
# Parse Nmap Ping
# by Javantea aka. Joel R. Voss
# Nov 11-13, 2005

from xml.dom.minidom import parse
import MySQLdb

verbose = False
mysql = True

def parse_host1(host, ports, output_file_prefix, conn = None):
	status = 'unknown'
	address = 'unknown'
	for info in host.childNodes:
		if info.nodeType == info.ELEMENT_NODE:
			if info.tagName == 'status':
				status = info.getAttribute('state')
				#print 'status', status
			elif info.tagName == 'address':
				if info.getAttribute('addrtype') == 'ipv4':
					address = info.getAttribute('addr')
				else:
					pass
				#end if
				#print 'address', address
			#end if
		#end if
	#next info
	# We have the info, so we can now use it.
	if verbose:
		print '#', address, 'is', status
	elif status == 'up':
		print 'nmap -sS -P0 -T2 -p', ports, '-oX', output_file_prefix + address + '.xml', address
	#end if
	if mysql:
		cursor = conn.cursor()
		cursor.execute("INSERT INTO host (id, ip) VALUES (0, '" + address + "');")
	#end if
#end def parse_host1(host, output_file_prefix, conn)

def parse_runstats1(runstats, conn = None):
	print '# stats'
	for stat in runstats.childNodes:
		if stat.nodeType == stat.ELEMENT_NODE:
			if stat.tagName == 'finished':
				print '# time =', stat.getAttribute('time')
			elif stat.tagName == 'hosts':
				print '# up =', stat.getAttribute('up')
			#end if
		#end if
	#next stat
#def parse_runstats1(runstats)

def parse_ping1(input_file, output_file_prefix = 'ns', ports = '21,22,23,25,37,53,80,113,135,139,443,445,1025,1433,3306,3389,5800,5900,6000,6881-6889'):
	dom1 = parse(input_file)
	
	conn = None
	if mysql:
		conn = MySQLdb.connect('localhost', 'inet', '', 'netmap1')
	#end if
	
	for host in dom1.documentElement.childNodes:
		if host.nodeType == host.ELEMENT_NODE:
			if host.tagName == 'host':
				parse_host1(host, ports, output_file_prefix, conn)
			elif host.tagName == 'runstats':
				parse_runstats1(host, conn)
			#end if
		#end if
	#next host
#end def parse_ping1(input_file, output_file_prefix, ports)

def main():
	from sys import argv
	infile = 'ping1.xml'
	output = 'port1_'
	if len(argv) > 1:
		infile = argv[1]
	#end if
	if len(argv) > 2:
		output = argv[2]
	#end if
	parse_ping1(infile, output)
#end def main()

if __name__ == '__main__':
	main()
#end if
